# Logging

Logging with Plexus is aided by the `Level` class. A `level` field is present on every `Event` and `Module` instance. The event and its source module's level can be utilized by handlers to filter which `Event`s are logged.

During initialization of the Plexus logger, the `package:logging` root level will be set to the same as the `RootModule` level and a handler will be registered that converts instances of `LogRecord` to `Event`. The `package:logging` root level will also be updated whenever the `RootModule` level is changed.

To log messages, errors, or other data, use the `log` method found on instances of `Module`. The log method, while designed primarily for logging debug information, can also be used for sharing data across your application, with the help of the `subscribe` method. Keep in mind that it is recommended that you instead use the `add` method with a custom `Event` subclass for this.
