# Modules

Plexus uses *Modules* to organize and manage events. A *Module* is essentially equivalent to a `Logger` from `package:logging`. All modules implement the `Module` interface, allowing you to implement custom behavior.

To attach a module to an arbitrary class, use the `HasModule` mixin and override the `package` getter. The package must be a (preferably constant) instance of `UnmodifiableListView` containing a list of strings composed solely of lowercase and uppercase letters, numbers, and underscores. It is preferable that this package follows typical reverse domain name notation, albeit starting the package with the Dart package name, omitting the "ext.company." usually found in reverse domain name notation.
